<!DOCTYPE html>
<html lang="en-us">
<head>

  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="generator" content="Source Themes Academic 3.1.0">
  <meta name="generator" content="Hugo 0.50" />
  <meta name="author" content="Jeremy Jackson">

  
  
  
  
    
  
  <meta name="description" content="Here&#39;s some information about my system config files.">

  
  <link rel="alternate" hreflang="en-us" href="https://ackso.net/post/my-terminal-configs/">

  


  

  

  

  
  
  
  <meta name="theme-color" content="#2962ff">
  

  
  
  
  
    
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.1.3/css/bootstrap.min.css" integrity="sha256-eSi1q2PG6J7g7ib17yAaWMcrr5GrtohYChqibrV7PBE=" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/academicons/1.8.6/css/academicons.min.css" integrity="sha256-uFVgMKfistnJAfoCUQigIl+JfUaP47GrRKjf6CTPVmw=" crossorigin="anonymous">
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.5.0/css/all.css" integrity="sha384-B4dIYHKNBt8Bc12p+WXckhzcICo0wtJAoU8YZTY5qE0Id1GSseTk6S+L3BlXeVIU" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/fancybox/3.2.5/jquery.fancybox.min.css" integrity="sha256-ygkqlh3CYSUri3LhQxzdcm0n1EQvH2Y+U5S2idbLtxs=" crossorigin="anonymous">

    
    
    
      
    
    
      
      
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/github.min.css" crossorigin="anonymous">
      
    

    

    

  

  
  
  <link rel="stylesheet" href="//fonts.googleapis.com/css?family=Montserrat:400,700|Roboto:400,400italic,700|Roboto+Mono">
  

  <link rel="stylesheet" href="/styles.css">
  

  
  
  

  
  <link rel="alternate" href="https://ackso.net/index.xml" type="application/rss+xml" title="Sometimes Jeremy Thinks">
  <link rel="feed" href="https://ackso.net/index.xml" type="application/rss+xml" title="Sometimes Jeremy Thinks">
  

  <link rel="manifest" href="/site.webmanifest">
  <link rel="icon" type="image/png" href="/img/icon.png">
  <link rel="apple-touch-icon" type="image/png" href="/img/icon-192.png">

  <link rel="canonical" href="https://ackso.net/post/my-terminal-configs/">

  <meta property="twitter:card" content="summary_large_image">
  
  <meta property="og:site_name" content="Sometimes Jeremy Thinks">
  <meta property="og:url" content="https://ackso.net/post/my-terminal-configs/">
  <meta property="og:title" content="My Terminal Configs | Sometimes Jeremy Thinks">
  <meta property="og:description" content="Here&#39;s some information about my system config files.">
  
  
    
  <meta property="og:image" content="https://ackso.net/img/icon-192.png">
  <meta property="og:locale" content="en-us">
  
  <meta property="article:published_time" content="2017-12-17T14:15:50-07:00">
  
  <meta property="article:modified_time" content="2017-12-17T14:15:50-07:00">
  

  

  

  <title>My Terminal Configs | Sometimes Jeremy Thinks</title>

</head>
<body id="top" data-spy="scroll" data-target="#TableOfContents" data-offset="71" >

<nav class="navbar navbar-light fixed-top navbar-expand-lg py-0" id="navbar-main">
  <div class="container">

    
      <a class="navbar-brand" href="/">Sometimes Jeremy Thinks</a>
      
      <button type="button" class="navbar-toggler" data-toggle="collapse"
              data-target="#navbar" aria-controls="navbar" aria-expanded="false" aria-label="Toggle navigation">
        <span><i class="fas fa-bars"></i></span>
      </button>
      

    
    <div class="collapse navbar-collapse" id="navbar">

      
      
      <ul class="navbar-nav ml-auto">
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#about">
            
            <span>Home</span>
            
          </a>
        </li>

        
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#posts">
            
            <span>Posts</span>
            
          </a>
        </li>

        
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#projects">
            
            <span>Projects</span>
            
          </a>
        </li>

        
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#contact">
            
            <span>Contact</span>
            
          </a>
        </li>

        
        

      

        

        
      </ul>

    </div>
  </div>
</nav>


<article class="article" itemscope itemtype="http://schema.org/Article">

  












  

  
  
  
<div class="article-container pt-3">
  <h1 itemprop="name">My Terminal Configs</h1>

  

  
    

<div class="article-metadata">

  
  
  <span itemscope itemprop="author" itemtype="http://schema.org/Person">
    <meta itemprop="name" content="Jeremy Jackson">
  </span>
  

  <span class="article-date">
    
    <meta content="2017-12-17 14:15:50 -0700 MST" itemprop="datePublished">
    <time datetime="2017-12-17 14:15:50 -0700 MST" itemprop="dateModified">
      2017-12-17
    </time>
  </span>
  <span itemscope itemprop="publisher" itemtype="http://schema.org/Person">
    <meta itemprop="name" content="Jeremy Jackson">
  </span>

  
  <span class="middot-divider"></span>
  <span class="article-reading-time">
    5 min read
  </span>
  

  
  
  <span class="middot-divider"></span>
  <a href="/post/my-terminal-configs/#disqus_thread"></a>
  

  

  
  
<div class="share-box" aria-hidden="true">
  <ul class="share">
    <li>
      <a class="twitter"
         href="https://twitter.com/intent/tweet?text=My%20Terminal%20Configs&amp;url=https%3a%2f%2fackso.net%2fpost%2fmy-terminal-configs%2f"
         target="_blank" rel="noopener">
        <i class="fab fa-twitter"></i>
      </a>
    </li>
    <li>
      <a class="facebook"
         href="https://www.facebook.com/sharer.php?u=https%3a%2f%2fackso.net%2fpost%2fmy-terminal-configs%2f"
         target="_blank" rel="noopener">
        <i class="fab fa-facebook-f"></i>
      </a>
    </li>
    <li>
      <a class="linkedin"
         href="https://www.linkedin.com/shareArticle?mini=true&amp;url=https%3a%2f%2fackso.net%2fpost%2fmy-terminal-configs%2f&amp;title=My%20Terminal%20Configs"
         target="_blank" rel="noopener">
        <i class="fab fa-linkedin-in"></i>
      </a>
    </li>
    <li>
      <a class="weibo"
         href="http://service.weibo.com/share/share.php?url=https%3a%2f%2fackso.net%2fpost%2fmy-terminal-configs%2f&amp;title=My%20Terminal%20Configs"
         target="_blank" rel="noopener">
        <i class="fab fa-weibo"></i>
      </a>
    </li>
    <li>
      <a class="email"
         href="mailto:?subject=My%20Terminal%20Configs&amp;body=https%3a%2f%2fackso.net%2fpost%2fmy-terminal-configs%2f">
        <i class="fas fa-envelope"></i>
      </a>
    </li>
  </ul>
</div>


  

</div>

    















  
</div>



  <div class="article-container">

    <div class="article-style" itemprop="articleBody">
      

<p>It&rsquo;s starting to become more popular for some hiring companies to request your
&ldquo;dot&rdquo; files to show how you configure your environment.
I figure this is probably intended to be something akin to a signalling mechanism,
meaning that you&rsquo;re into the weeds enough to know that on *NIX systems you have
configuration files for each user on the system, typically prefixed with a &ldquo;dot&rdquo;.
Hence we have files like <code>.bashrc</code> that gets executed when you open a new bash
session and sets up the environment for you.
Same for vim, where you have the <code>.vimrc</code> file.
You can potentially have many more (including &ldquo;dot&rdquo; folders, like <code>.ssh</code>), just
depending on what software you use on a regular basis on your *NIX system.</p>

<p>So I want to show and explain a few of my &ldquo;dot&rdquo; files here, but first, I have a gripe.</p>

<p>The point of having systems that, to whatever extent they may, conform to POSIX
standards is to facilitate interoperability.
Not only of systems, but users also.
That&rsquo;s why things like <code>vi</code>, <code>nano</code>, and <code>gnu-utils</code> are pretty uniformly auto-installed
on *NIX systems.
That makes it easy for me, Sue the Admin, or Joe the Developer to log in to a
system they never have and at least know the tools available to them.
For that reason, I&rsquo;m not a huge fan of doing a lot of customization of my &ldquo;dot&rdquo; files
and I try to encourage people to know the defaults quite well prior to customizing.</p>

<p>End of gripe.</p>

<h2>Table of Contents</h2>
<nav id="TableOfContents">
<ul>
<li><a href="#justification">Justification</a></li>
<li><a href="#bashrc">.bashrc</a></li>
<li><a href="#vimrc">.vimrc</a></li>
<li><a href="#tmux-conf">.tmux.conf</a></li>
</ul>
</nav>


<h1 id="justification">Justification</h1>

<p>So I just finished up my gripe about not using the standard tools and I&rsquo;m about to start
talking about <code>vim</code> and <code>tmux</code>, neither of which fall into that &ldquo;ubiquitously installed&rdquo;
category.
Well, there&rsquo;s a reason for that.</p>

<p>I like <code>vi</code> well enough and can definitely use it without any troubles.
However, <code>vim</code> gives me some added functionality that is really useful for doing
development work, particularly <code>syntastic</code> for syntax checking/linting, <code>EDITORCONFIG</code>,
and some additional keybind functionalities that are just missing from <code>vi</code>.</p>

<p>Then there&rsquo;s <code>tmux</code>.
Again, <code>screen</code> is perfectly good and I can use it well enough, but there were just
some things that didn&rsquo;t work the way I was hoping.
For instance, <code>screen</code> requires a lot more combination keybinds to do things that
I would hope would be much simpler, such as splitting panes.
Also, <code>tmux</code>&rsquo;s configurability is quite a bit stronger.</p>

<h1 id="bashrc">.bashrc</h1>

<p>My <code>.bashrc</code> is fairly plain-jane.
The only things that I&rsquo;ve added are to put a few things in <code>$PATH</code> that are not
enabled by default, like snaps (I&rsquo;m on BunsenLabs Helium/Debian Stretch).
I don&rsquo;t have any special aliases for things that I use a lot because I value
that muscle memory of being able to quickly use the standard built-in tools.</p>

<p>So, my <code>.bashrc</code> is the standard <code>.bashrc</code> that you get when creating a new user
on a Debian system, with the following two lines added at the end.</p>

<pre><code>export PATH=$PATH:/snap/bin
export EDITOR='vim'
</code></pre>

<h1 id="vimrc">.vimrc</h1>

<p>My <code>.vimrc</code> has a bit more customization for things like <code>EDITORCONFIG</code>, <code>syntastic</code>,
and the <code>solarized</code> color scheme.
Still no special aliases for doing special things.
You&rsquo;ll notice nothing about <code>EDITORCONFIG</code> here, but it&rsquo;s being brought in by <code>pathogen</code>.</p>

<pre><code>set nocompatible
syntax on
set autoindent		&quot; always set autoindenting on
set smartindent
set nowrap		&quot; turns off text wrapping
set number 		&quot; turns line numbering on
colorscheme solarized
set background=dark
set ruler		&quot; show the cursor position all the time

set smarttab
set softtabstop=2
set expandtab
set shiftwidth=2
set tabstop=2
filetype indent plugin on
set showcmd
set hlsearch
set ignorecase
set smartcase
set ruler
set laststatus=2
set confirm

set cmdheight=2

&quot; Disable python-mode in favor of syntastic
let g:pymode_lint = 0
let g:pymode_lint_on_write = 0

&quot; Syntastic setup
let g:syntastic_aggregate_errors = 1
let g:syntastic_always_populate_loc_list = 1
let g:syntastic_auto_loc_list = 1
let g:syntastic_auto_jump = 1
let g:syntastic_check_on_open = 1
let g:syntastic_check_on_wq = 0
let g:syntastic_javascript_checkers = ['eslint']
let g:syntastic_python_checkers = ['pep8', 'python']
let g:syntastic_tex_checkers = ['lacheck']

let Vimplate=&quot;/usr/bin/vimplate&quot;

&quot; Pathogen config
execute pathogen#infect()
</code></pre>

<h1 id="tmux-conf">.tmux.conf</h1>

<p>Again, not doing much special with tmux.
I&rsquo;ve considered setting up my usual pane layout to automatically be used when I
start a new <code>tmux</code> session, but I just haven&rsquo;t gotten around to it.
Most of these are the defaults.
The only ones I&rsquo;ve changed are to have a 256 color terminal (because baller),
change the pane index to be 1-based instead of 0-based because it makes it easier
to switch panes one-handed, letting tmux now that I use vim, and making the pane
numbers display a bit longer on screen to give me a second to decide which pane
I want to switch to.</p>

<p>My standard setup is 3-panes, with my main pane vertical on the right, and the other
two panes split horizontally on the left.
I like this better since it puts the vertical center line between the panes near the
middle of my screen, and therefore the left edge of my text editor is pretty close
to the middle of the screen as well.
<code>tmux</code> actually has a layout preset that&rsquo;s pretty similar to this called <code>main-vertical</code>,
however it puts the large &ldquo;main&rdquo; vertical pane on the left instead of the right.
Putting my main pane closer to the middle of the screen is definitely a bit more
natural since that&rsquo;s where my attention will naturally be drawn.</p>

<pre><code>set -g default-terminal &quot;tmux-256color&quot;
set -g pane-base-index 1
set-window-option -g mode-keys vi
set -g display-panes-time 3000
set -g display-time 3000
set -g status-fg cyan # ThG original was: white
set -g status-bg default
set -g status-attr default
set -g status-left &quot;&quot;
if '[ -z &quot;$DISPLAY&quot; ]' 'set -g status-left &quot;[#[fg=green] #H #[default]]&quot;'
if '[ -z &quot;$DISPLAY&quot; ]' 'set -g status-right &quot;[ #[fg=magenta]#(cat /proc/loadavg | cut -d \&quot; \&quot; -f 1,2,3)#[default] ][ #[fg=cyan,bright]%a %Y-%m-%d %H:%M #[default]]&quot;'
if '[ -z &quot;$DISPLAY&quot; ]' 'set -g status-right-length 50'
</code></pre>

    </div>

    


<div class="article-tags">
  
  <a class="badge badge-light" href="/tags/environment/">environment</a>
  
  <a class="badge badge-light" href="/tags/configs/">configs</a>
  
</div>



    






<div class="media author-card" itemscope itemtype="http://schema.org/Person">
  
  <img class="portrait mr-3" src="/img/portrait.jpg" itemprop="image" alt="Avatar">
  
  <div class="media-body">
    <h5 class="card-title" itemprop="name"><a href="/">Jeremy Jackson</a></h5>
    <h6 class="card-subtitle">Software Engineering and Data Science</h6>
    
    <ul class="network-icon" aria-hidden="true">
      
      
      
      
      
      
      
      
      <li>
        <a itemprop="sameAs" href="mailto:jeremy_j@ackso.net" >
          <i class="fa fa-envelope"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//twitter.com/jeremy_j_ackso" >
          <i class="fab fa-twitter"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//github.com/jeremy-j-ackso" >
          <i class="fab fa-github"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//gitlab.com/jeremy.jackson" >
          <i class="fab fa-gitlab"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//linkedin.com/in/jeremy-jackson-249878153" >
          <i class="fab fa-linkedin"></i>
        </a>
      </li>
      
    </ul>
  </div>
</div>




    
    

    

    
<section id="comments">
  <div id="disqus_thread"></div>
<script type="application/javascript">
    var disqus_config = function () {
    
    
    
    };
    (function() {
        if (["localhost", "127.0.0.1"].indexOf(window.location.hostname) != -1) {
            document.getElementById('disqus_thread').innerHTML = 'Disqus comments not available by default when the website is previewed locally.';
            return;
        }
        var d = document, s = d.createElement('script'); s.async = true;
        s.src = '//' + "ackso-net.disqus.com" + '.disqus.com/embed.js';
        s.setAttribute('data-timestamp', +new Date());
        (d.head || d.body).appendChild(s);
    })();
</script>
<noscript>Please enable JavaScript to view the <a href="https://disqus.com/?ref_noscript">comments powered by Disqus.</a></noscript>
<a href="https://disqus.com" class="dsq-brlink">comments powered by <span class="logo-disqus">Disqus</span></a>
</section>



  </div>
</article>

<div class="container">
  <footer class="site-footer">
  

  <p class="powered-by">
    &copy; 2017 Jeremy T Jackson &middot; 

    Powered by the
    <a href="https://sourcethemes.com/academic/" target="_blank" rel="noopener">Academic theme</a> for
    <a href="https://gohugo.io" target="_blank" rel="noopener">Hugo</a>.

    
    <span class="float-right" aria-hidden="true">
      <a href="#" id="back_to_top">
        <span class="button_icon">
          <i class="fas fa-chevron-up fa-2x"></i>
        </span>
      </a>
    </span>
    
  </p>
</footer>

</div>


<div id="modal" class="modal fade" role="dialog">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title">Cite</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        <pre><code class="tex hljs"></code></pre>
      </div>
      <div class="modal-footer">
        <a class="btn btn-outline-primary my-1 js-copy-cite" href="#" target="_blank">
          <i class="fas fa-copy"></i> Copy
        </a>
        <a class="btn btn-outline-primary my-1 js-download-cite" href="#" target="_blank">
          <i class="fas fa-download"></i> Download
        </a>
        <div id="modal-error"></div>
      </div>
    </div>
  </div>
</div>

    

    
    
    
    
    <script src="/js/mathjax-config.500a6cbb2c0f345fcecc21b3116d6637aa78f1f11db8081ea581abe05390c2e8f3bbffe61be3cf0217baf785c40efceabe51050a4f007e69af94efd3643260e8.js" integrity="sha512-UApsuywPNF/OzCGzEW1mN6p48fEduAgepYGr4FOQwujzu//mG&#43;PPAhe694XEDvzqvlEFCk8AfmmvlO/TZDJg6A=="></script>
    

    
    
    
      <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.3.1/jquery.min.js" integrity="sha512-+NqPlbbtM1QqiK8ZAo4Yrj2c4lNQoGv8P79DPtKzj++l5jnN39rHA/xsqn8zE9l0uSoxaCdrOgFs6yjyfbBxSg==" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.imagesloaded/4.1.3/imagesloaded.pkgd.min.js" integrity="sha512-umsR78NN0D23AzgoZ11K7raBD+R6hqKojyBZs1w8WvYlsI+QuKRGBx3LFCwhatzBunCjDuJpDHwxD13sLMbpRA==" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.1.3/js/bootstrap.min.js" integrity="sha256-VsEqElsCHSGmnmHXGQzvoWjWwoznFSZc6hs7ARLRacQ=" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.isotope/3.0.4/isotope.pkgd.min.js" integrity="sha512-VDBOIlDbuC4VWxGJNmuFRQ0Li0SKkDpmGyuhAG5LTDLd/dJ/S0WMVxriR2Y+CyPL5gzjpN4f/6iqWVBJlht0tQ==" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/fancybox/3.2.5/jquery.fancybox.min.js" integrity="sha256-X5PoE3KU5l+JcX+w09p/wHl9AzK333C4hJ2I9S5mD4M=" crossorigin="anonymous"></script>

      
        
        <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js" integrity="sha256-/BfiIkHlHoVihZdc6TFuj7MmJ0TWcWsMXkeDFwhi0zw=" crossorigin="anonymous"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/python.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/r.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/bash.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/css.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/diff.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/javascript.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/json.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/markdown.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/nginx.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/processing.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/scala.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/sql.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/tex.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/vim.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/yaml.min.js"></script>
        
      

      
      
      <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.4/MathJax.js?config=TeX-AMS_CHTML-full" integrity="sha256-GhM+5JHb6QUzOQPXSJLEWP7R73CbkisjzK5Eyij4U9w=" crossorigin="anonymous" async></script>
      
    

    <script src="/js/hugo-academic.js"></script>
    

    
    

    
    
    
    <script id="dsq-count-scr" src="//ackso-net.disqus.com.disqus.com/count.js" async></script>
    

    
    
    <script>hljs.initHighlightingOnLoad();</script>
    

    
    
    <script>
      const search_index_filename = "/index.json";
      const i18n = {
        'placeholder': "Search...",
        'results': "Search Results",
        'no_results': "No results found"
      };
      const content_type = {
        'post': "Posts",
        'project': "Projects",
        'publication' : "Publications",
        'talk' : "Talks"
        };
    </script>
    

    
    

    

    
    

    
    

  </body>
</html>

